Map = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
}

function love.load()
	light = love.graphics.newImage("flashlight.png")
	playerimg = love.graphics.newImage("player.png")
	him = love.graphics.newImage('him.png')
	playerx = 410
	playery = 310
	playerr = 10
	players = 150
	genMap(80)
	lightr = 0
	go = true
	isThere = 0
	canFlash = 0
	wait = 0
	flicker = false
	timer = 0
	ITChance = 20
	hesthere = love.audio.newSource("Hesthere.ogg")
	gots = love.audio.newSource("gotten.ogg")
	timesup = love.audio.newSource("timesup.ogg")
	ambience = love.audio.newSource("ambience.ogg")
	footstep = love.audio.newSource("footstep.ogg")
	ambience:setLooping(true)
	footstep:setLooping(true)
	footstep:setVolume(0.3)
	loopT = footstep:getDuration()
	gotten = 0
	mx = 0
	my = 0
	md = 0
	ms = 153
	mdir = 0
	msi = 1 
	theEnd = true
	textcolor = {255, 255, 255, 0}
	font = love.graphics.getFont()
	text = 'Use the mouse to move, Find the 5 artifacts'
	idlego = true
end

function love.update(dt)
	windowW = love.graphics.getWidth()
	windowH = love.graphics.getHeight()
	mousex, mousey = love.mouse.getPosition()
	lightr = math.atan2(mousey - windowH/2, mousex - windowW/2)
	cos = math.cos(lightr)
	sin = math.sin(lightr)

	mdir = math.atan2(playery - my, playerx - mx)
	if mx > playerx then msi = -1 else msi = 1 end

	math.randomseed(os.time())
	if love.mouse.isDown(1) then
		playery = playery + players * dt * sin
		playerx = playerx + players * dt * cos
		idlego = true
		loopT = loopT - dt
		if loopT < 0 then
			footstep:setPitch(0.01 * love.math.random(80, 100))
			loopT = footstep:getDuration()
		end
		love.audio.play(footstep)
	else
		love.audio.stop(footstep)
		if idlego then
			my = playery
			mx = playerx
			while mx == playerx and my == playery do
				mx = playerx + 180 * love.math.random(-1, 1)
				my = playery + 180 * love.math.random(-1, 1)
			end
			idlego = false
		end
		local lcos = math.cos(mdir)
		local lsin = math.sin(mdir)
		local dist = getDistance(playerx, playery, mx, my)
		if dist > 150 then
			mx = mx + (dist/180 * 25 * lcos * dt)
			my = my + (dist/180 * 25 * lsin * dt)
		end
	end

	if playerx < -600 or playerx > 2600  or playery < -300 or playery > 1700 then 
		playery = playery - players * dt * sin
		playerx = playerx - players * dt * cos
	end

	wait = wait - dt
	timer = timer + dt

	flicker = (gotten > 0 and gotten < 5 and timer < 300)

	love.audio.setVolume(1)
	if timer > 300 or gotten == 5 then 
		love.audio.play(timesup)
		if theEnd then 
			mx = playerx + 300 * cos
			my = playery + 300 * sin
			theEnd = false
		end
		mdir = math.atan2(playery - my, playerx - mx)
		local lcos = math.cos(mdir)
		local lsin = math.sin(mdir)
		mx = mx + (ms * lcos * dt)
		my = my + (ms * lsin * dt)
	end

	if flicker then love.audio.play(ambience) end

	if Map[math.floor((playery + 500)/200)][math.floor((playerx + 800)/200)] == 2 then
		Map[math.floor((playery + 500)/200)][math.floor((playerx + 800)/200)] = 0
		gotten = gotten + 1
		love.audio.stop(gots)
		love.audio.play(gots)
		ITChance = ITChance - 2
	end

	if timer < 2 and textcolor[4] < 255 and timer < 10 then textcolor[4] = textcolor[4] + 123 * dt end
	if timer > 7 and textcolor[4] > 0  and timer < 9 then textcolor[4] = textcolor[4] - 123 * dt end
	if timer > 9 and textcolor[4] < 255  and timer < 16 then
		text = 'You have 5 minutes'
		textcolor[4] = textcolor[4] + 123 * dt
	end
	if timer > 16 and textcolor[4] > 0 then textcolor[4] = textcolor[4] - 123 * dt end
end

function love.draw()
	love.graphics.push()
	love.graphics.setBackgroundColor(123, 123, 123)

	if timer > 300 or gotten == 5 then
		displacementx = 3 - love.math.random(1, 6)
		displacementy = 3 - love.math.random(1, 6)
	else
		displacementx = 0
		displacementy = 0
	end

	love.graphics.translate(windowW/2 - playerx + displacementx, windowH/2 - playery + displacementy)
	-- love.graphics.scale(0.1, 0.1)

	love.graphics.setBlendMode("alpha")

	for y=0,11 do
		for x=0,17 do
			love.graphics.setColor(255, 255, 255, 255)
			if y == 0 or y == 11 or x == 0 or x == 17 then love.graphics.rectangle("fill", x*200 - 800, y*200 - 500, 200, 200) end
		end
	end

	love.graphics.circle("fill", playerx, playery, 20)

	math.randomseed(1)

	for y,row in ipairs(Map) do
		for x,tile in ipairs(row) do
			love.graphics.setColor(255, 255, 0, 255)
			if tile == 2 then love.graphics.rectangle("fill", x*200-(100 * #row/2) + 75, y*200-(100 * #Map/2) + 75, 50, 50) end
			love.graphics.setColor(0, 123, 0, 255)
			if tile == 1 then love.graphics.circle("fill", x*200-(100 * #row/2), y*200-(100 * #Map/2), 110) end
			if y ~= 1 and y ~= 10 and x ~= 1 and x ~= 16 and tile == 1 then
				if Map[y-1][x] == 1 then love.graphics.circle("fill", x*200-(100 * #row/2), (y-0.5+(1-2*math.random()))*200-(100 * #Map/2), 110) end
				if Map[y+1][x] == 1 then love.graphics.circle("fill", x*200-(100 * #row/2), (y+0.5+(1-2*math.random()))*200-(100 * #Map/2), 110) end
				if Map[y][x-1] == 1 then love.graphics.circle("fill", (x-0.5+(1-2*math.random()))*200-(100 * #row/2), y*200-(100 * #Map/2), 110) end
				if Map[y][x+1] == 1 then love.graphics.circle("fill", (x+0.5+(1-2*math.random()))*200-(100 * #row/2), y*200-(100 * #Map/2), 110) end
			end
		end
	end

	math.randomseed(os.time())

	love.graphics.setColor(255, 0, 0, 255)
	if (canFlash <= 98 and isThere == 1) or timer > 300 or gotten == 5 or not idlego then love.graphics.draw(him, mx, my, 0, 1.5 * msi, 1.5, 25, 25) end

	if wait < 0 and flicker then canFlash = love.math.random(1, 100) elseif wait < 0 then canFlash = 0 end
	if getDistance(playerx, playery, mx, my) < 160 and ((canFlash <= 98 and isThere == 1) or timer > 300 or gotten == 5 or not idlego) then 
		canFlash = 100
		wait = 0.1 * love.math.random(1, 5)
	end
	if love.mouse.isDown(1) then
		if canFlash <= 98 and isThere == 1 and go then
			mx = playerx + 250 * cos
			my = playery + 250 * sin
			go = false
		end
		if canFlash > 98 then 
			isThere = love.math.random(1, math.floor(ITChance))
			go = true
		end
		if canFlash > 98 and wait < 0 then wait = 0.1 * love.math.random(1, 5) end
	  if canFlash <= 98 then love.graphics.draw(light, playerx, playery, lightr, 1, 1, 500, 500) else love.graphics.draw(playerimg, playerx, playery, lightr, 1, 1, 500, 500) end
	else
		love.graphics.draw(playerimg, playerx, playery, 0, 1, 1, 500, 500) 
		isThere = 15
	end

	if isThere == 1 and canFlash <= 98 then 
		love.audio.play(hesthere)
	else 
		love.audio.stop(hesthere) 
	end

	for y=-5,16 do
		for x=-5,22 do
			love.graphics.setColor(0, 0, 0, 255)
			if y < 0 or y > 11 or x < 0 or x > 17 then love.graphics.rectangle("fill", x*200 - 800, y*200 - 500, 200, 200) end
		end
	end

	love.graphics.pop()

	love.graphics.setColor(textcolor)
	love.graphics.print(text, windowW/2 - font:getWidth(text), windowH/2 - 100, 0, 2, 2)

	if getDistance(playerx, playery, mx, my) < 2 and (timer > 300 or gotten == 5) then love.event.quit() end
end

function genMap(amount)
	local q = amount
	while q > 0 do
		for y,row in ipairs(Map) do
			for x,tile in ipairs(row) do
				local go = love.math.random(1, 50)
				if go == 1 and q > 0 and tile == 0 then 
					Map[y][x] = 1 
					q = q - 1
				end
			end
		end
	end
	q = 5
	while q > 0 do
		for y,row in ipairs(Map) do
			for x,tile in ipairs(row) do
				local go = love.math.random(1, 50)
				if go == 1 and q > 0 and tile == 0 then 
					Map[y][x] = 2 
					q = q - 1
				end
			end
		end
	end
end

function getDistance(x1, y1, x2, y2)
	dx = (x1 - x2)
	dy = (y1 - y2)

	return math.sqrt(dx ^ 2 + dy ^ 2)
end